# m4 stuff
include(/usr/`include'/carl/config.m4)dnl

# Variables for soundfile-oriented aliases.
# The first two are site-dependent.
# Location of binaries
if (! ${?BINSF}) setenv BINSF	m4DESTDIR
# Location of root of default soundfile partition.
if (! ${?ROOT_SFDIR}) setenv	ROOT_SFDIR /snd
# User's home soundfile directory
if (! ${?HOME_SFDIR}) setenv	HOME_SFDIR $ROOT_SFDIR/$user
# User's current soundfile directory
if (! ${?SFDIR}) setenv	SFDIR	$HOME_SFDIR

# Aliases for soundfile-oriented commands.
alias	aimonitor	'(cd $SFDIR; $BINSF/aimonitor \!*)'
alias	aiplay	'(cd $SFDIR; $BINSF/aiplay \!*)'
alias	airecord	'(cd $SFDIR; $BINSF/airecord \!*)'
alias	catsf	'(cd $SFDIR; $BINSF/catsf \!*)'
alias	cdsf	'set TEMP_CWD=$cwd; set TEMP_STATUS=1;set ARGS=(\!*);(cd $SFDIR;cd \!*;if($#ARGS == 0)cd $HOME_SFDIR);if($status) set TEMP_STATUS=0;if($TEMP_STATUS) cd $SFDIR; if($TEMP_STATUS)cd \!*;if($#ARGS == 0)cd $HOME_SFDIR;if($TEMP_STATUS)setenv SFDIR $cwd;cd $TEMP_CWD; unset TEMP_STATUS ARGS TEMP_CD'
alias	chgrpsf	'(cd $SFDIR; /bin/chgrp \!*)'
alias	chmodsf	'(cd $SFDIR; /bin/chmod \!*)'
alias	chownsf	'(cd $SFDIR; /etc/chown \!*)'
alias	cpsf	'(cd $SFDIR; /bin/cp \!*)'
alias	createsf	'(cd $SFDIR; $BINSF/createsf \!*)'
alias	dsplay	'(cd $SFDIR; $BINSF/dsplay \!*)'
alias	dsrecord	'(cd $SFDIR; $BINSF/dsrecord \!*)'
alias	dyplay	'(cd $SFDIR; $BINSF/dyplay \!*)'
alias	dyrecord	'(cd $SFDIR; $BINSF/dyrecord \!*)'
alias	fromsf	'(cd $SFDIR; $BINSF/fromsf \!*)'
alias	gainsf	'(cd $SFDIR; $BINSF/gainsf \!*)'
# lsf looks for $SFDIR internally
# alias	lsf	'(cd $SFDIR; $BINSF/lsf \!*)'
alias	mkdirsf	'(cd $SFDIR; /bin/mkdir \!*)'
alias	mksfdir	mkdirsf
alias	monitor	'(cd $SFDIR; $BINSF/aimonitor \!*)'
alias	mvsf	'(cd $SFDIR; /bin/mv \!*)'
alias	normsf	'(cd $SFDIR; $BINSF/normsf \!*)'
alias	pansf	'(cd $SFDIR; $BINSF/pansf \!*)'
alias	peaksf	'(cd $SFDIR; $BINSF/peaksf \!*)'
alias	play	'(cd $SFDIR; $BINSF/aiplay \!*)'
alias	pwdsf	'(cd $SFDIR; /bin/pwd \!*)'
alias	pwsf	pwdsf
alias	querysf	'(cd $SFDIR; $BINSF/querysf \!*)'
alias	record	'(cd $SFDIR; $BINSF/airecord \!*)'
alias	restorsf	'(cd $SFDIR; $BINSF/restorsf \!*)'
alias	retrosf	'(cd $SFDIR; $BINSF/retrosf \!*)'
alias	rmdirsf	'(cd $SFDIR; /bin/rmdir \!*)'
alias	rmsf	'(cd $SFDIR; /bin/rm \!*)'
alias	scalesf	'(cd $SFDIR; $BINSF/scalesf \!*)'
alias	setsf	'(cd $SFDIR; $BINSF/setsf \!*)'
alias	sfcreate	'(cd $SFDIR; $BINSF/createsf \!*)'
alias	sndawk	'(cd $SFDIR; $BINSF/sndawk \!*)'
alias	sndcat	'(cd $SFDIR; $BINSF/catsf \!*)'
alias	sndgain	'(cd $SFDIR; $BINSF/gainsf \!*)'
alias	sndin	'(cd $SFDIR; $BINSF/fromsf \!*)'
alias	sndinfo	'(cd $SFDIR; $BINSF/querysf \!*)'
alias	sndnorm	'(cd $SFDIR; $BINSF/normsf \!*)'
alias	sndout	'(cd $SFDIR; $BINSF/tosf \!*)'
alias	sndpan	'(cd $SFDIR; $BINSF/pansf \!*)'
alias	sndpeak	'(cd $SFDIR; $BINSF/peaksf \!*)'
alias	sndreverse	'(cd $SFDIR; $BINSF/retrosf \!*)'
alias	sndscale	'(cd $SFDIR; $BINSF/scalesf \!*)'
alias	sndset	'(cd $SFDIR; $BINSF/setsf \!*)'
alias	sndtransp	'(cd $SFDIR; $BINSF/transpsf \!*)'
alias	swabsf	'(cd $SFDIR; $BINSF/swabsf \!*)'
alias	tarsf	'(cd $SFDIR; $BINSF/tarsf \!*)'
alias	tosf	'(cd $SFDIR; $BINSF/tosf \!*)'
alias	transpsf	'(cd $SFDIR; $BINSF/transpsf \!*)'
